Subject: bug#66096: High CPU usage, basically runaway emacs with visit to bidi_cache_search on and off?

From: Eli Zaretskii <[email-masked]>
Date: Wed, 20 Sep 2023 16:24:35 +0300

> Date: Wed, 20 Sep 2023 16:09:03 +0900
> Cc: [email-masked], "ishikawa, chiaki" <[email-masked]>
> From: "ISHIKAWA,chiaki" <[email-masked]>
> 
> I have the following code snippet to monitor GC issues on my PC for 
> quite sometime.
> But I have not seen this particular problem before.
> The long pause I have seen before was strictly in GC-related routines.
> 
> (setq my-gc-statistics (make-vector 30 nil))
> 
> ;;; The element is
> ;;; (append (memory-use-counts) (list gc-elapsed gcs-done))
> ;;; Each time the following function is called, the
> ;;; elements in the array is shifted toward the end.
> ;;; Use (message "%S" my-gc-statistics) to force the
> ;;; recording of my-gc-statistics value in *Messages* buffer for later 
> analysis.
> 
> 
> (defun update-my-gc-statistics ()
>    (let ((i 28))
>      (progn
>       ;;; very unlike Lisp
>       (while (<= 0 i)
>         (progn (aset my-gc-statistics (+ 1 i) (aref my-gc-statistics i))
>               (setq i (- i 1) )))
>       (aset my-gc-statistics 0
>             (append (memory-use-counts) (list gc-elapsed gcs-done)))
>       ;;; print the latest one last so that I can see the glimpse in the 
> narrow
>       ;;; output window.
>       (message "%S\n%S" (current-time-string) (pp (reverse 
> my-gc-statistics))))))
> 
> (setq post-gc-hook 'update-my-gc-statistics)
> 
> For example, in one place, I see
> #0  0x0000556f1905be9e in string_char_and_length
>      (length=<synthetic pointer>, p=0x556f20d8a3d8 " 70337 417360 
> 2.323839139 50)\n (99058573 3875 59193441 34949 11084445 70337 417401 
> 2.391973008 51)]\n\"") at 
> /home/ishikawa/repos/emacs-29.1/src/character.h:375
> 
> And that string is probably   from (append (memory-use-counts) (list 
> gc-elapsed gcs-done))

I tried to run with this, and I don't see any such infloop.  I see the
GC results displayed in the echo-area once in a while.

I guess some other customizations cause this, or maybe some special
circumstances with different fonts you use.  Customizations that
affect the echo-area display and resizing are of main interest.  If
you can try to reproduce this in "emacs -Q", with only the
post-gc-hook defined and as little of your other customizations as
possible, it could help.

> Also I see recursive_edit at the bottom of the stakctrace.
> Not sure why. Maybe I was doing some error recovery of Japanese input?

No, this is normal: Emacs enters one level of recursive-edit when it
starts.